# coding: utf-8

"""
    VMware Aria Automation Assembler / Service Broker API

    A multi-cloud API for Cloud Automation Services  The APIs that list collections of resources also support OData like implementation. Below query params can be used across Assembler / Service Broker entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/catalog/api/items?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/catalog/api/items?$top=10&$skip=2```  3. `page` and `size` - page used in conjunction with `$size` helps in pagination of resources.      ```/catalog/api/items?page=0&size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /catalog/api/items?$filter=startswith(name, 'Act')     /catalog/api/items?$filter=toupper(name) eq 'ACTIVATE'     /catalog/api/items?$filter=substringof('renameVM', name)     /catalog/api/items?$filter=name eq 'ABCD'  # noqa: E501

    OpenAPI spec version: 2020-08-25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PolicyDecisionObjectNodePolicies(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'status': 'str',
        'rank': 'int',
        'name': 'str',
        'enforcement_type': 'str',
        'project_id': 'str'
    }

    attribute_map = {
        'id': 'id',
        'status': 'status',
        'rank': 'rank',
        'name': 'name',
        'enforcement_type': 'enforcementType',
        'project_id': 'projectId'
    }

    def __init__(self, id=None, status=None, rank=None, name=None, enforcement_type=None, project_id=None):  # noqa: E501
        """PolicyDecisionObjectNodePolicies - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._status = None
        self._rank = None
        self._name = None
        self._enforcement_type = None
        self._project_id = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if status is not None:
            self.status = status
        if rank is not None:
            self.rank = rank
        if name is not None:
            self.name = name
        if enforcement_type is not None:
            self.enforcement_type = enforcement_type
        if project_id is not None:
            self.project_id = project_id

    @property
    def id(self):
        """Gets the id of this PolicyDecisionObjectNodePolicies.  # noqa: E501


        :return: The id of this PolicyDecisionObjectNodePolicies.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PolicyDecisionObjectNodePolicies.


        :param id: The id of this PolicyDecisionObjectNodePolicies.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def status(self):
        """Gets the status of this PolicyDecisionObjectNodePolicies.  # noqa: E501


        :return: The status of this PolicyDecisionObjectNodePolicies.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this PolicyDecisionObjectNodePolicies.


        :param status: The status of this PolicyDecisionObjectNodePolicies.  # noqa: E501
        :type: str
        """
        allowed_values = ["NOT_ENFORCED", "ENFORCED", "CONFLICT"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def rank(self):
        """Gets the rank of this PolicyDecisionObjectNodePolicies.  # noqa: E501


        :return: The rank of this PolicyDecisionObjectNodePolicies.  # noqa: E501
        :rtype: int
        """
        return self._rank

    @rank.setter
    def rank(self, rank):
        """Sets the rank of this PolicyDecisionObjectNodePolicies.


        :param rank: The rank of this PolicyDecisionObjectNodePolicies.  # noqa: E501
        :type: int
        """

        self._rank = rank

    @property
    def name(self):
        """Gets the name of this PolicyDecisionObjectNodePolicies.  # noqa: E501


        :return: The name of this PolicyDecisionObjectNodePolicies.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PolicyDecisionObjectNodePolicies.


        :param name: The name of this PolicyDecisionObjectNodePolicies.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def enforcement_type(self):
        """Gets the enforcement_type of this PolicyDecisionObjectNodePolicies.  # noqa: E501


        :return: The enforcement_type of this PolicyDecisionObjectNodePolicies.  # noqa: E501
        :rtype: str
        """
        return self._enforcement_type

    @enforcement_type.setter
    def enforcement_type(self, enforcement_type):
        """Sets the enforcement_type of this PolicyDecisionObjectNodePolicies.


        :param enforcement_type: The enforcement_type of this PolicyDecisionObjectNodePolicies.  # noqa: E501
        :type: str
        """
        allowed_values = ["SOFT", "HARD"]  # noqa: E501
        if enforcement_type not in allowed_values:
            raise ValueError(
                "Invalid value for `enforcement_type` ({0}), must be one of {1}"  # noqa: E501
                .format(enforcement_type, allowed_values)
            )

        self._enforcement_type = enforcement_type

    @property
    def project_id(self):
        """Gets the project_id of this PolicyDecisionObjectNodePolicies.  # noqa: E501


        :return: The project_id of this PolicyDecisionObjectNodePolicies.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this PolicyDecisionObjectNodePolicies.


        :param project_id: The project_id of this PolicyDecisionObjectNodePolicies.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PolicyDecisionObjectNodePolicies, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PolicyDecisionObjectNodePolicies):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
